import unittest
from StaticTypedList import *


class MyTestCase(unittest.TestCase):
    def test_all(self):
        self.assertEquals(len(StaticTypedList(int, [3, 5, 8, 2, 7])), 5)
        self.assertEquals(len(StaticTypedList(int, [3, 5, 8, 2, 7, 7])), 6)
        self.assertEquals(len(StaticTypedList(int, [4, 2])), 2)
        a: StaticTypedList = StaticTypedList(int, [2, 7])
        self.assertEquals(len(a), 2)
        a.append(5)
        self.assertEquals(len(a), 3)
        self.assertTrue(7 in a)
        a.remove(7)
        self.assertEquals(len(a), 2)
        self.assertTrue(6 not in a)
        a.remove(6)  # Element not in the list
        self.assertEquals(len(a), 2)
        self.assertEquals(a, [2, 5])
        b: StaticTypedList = StaticTypedList(int, [3, 5, 1])
        a.extend(b)
        self.assertEquals(len(a), 5)
        self.assertEquals(a, [2, 5, 3, 5, 1])
        a.insert(1, 6)
        self.assertEquals(len(a), 6)
        self.assertEquals(a, [2, 6, 5, 3, 5, 1])
        a.insert(7, 7)
        self.assertEquals(len(a), 7)
        self.assertEquals(a, [2, 6, 5, 3, 5, 1, 7])
        a.pop()
        self.assertEquals(len(a), 6)
        self.assertEquals(a, [2, 6, 5, 3, 5, 1])
        self.assertEquals(a.count(5), 2)
        self.assertEquals(a.index(5), 2)
        a.pop(2)
        self.assertEquals(len(a), 5)
        self.assertEquals(a, [2, 6, 3, 5, 1])
        self.assertEquals(a.count(5), 1)
        self.assertEquals(a.index(5), 3)
        self.assertEquals(b, [3, 5, 1])
        self.assertEquals(len(b), 3)
        b.reverse()
        self.assertEquals(len(b), 3)
        self.assertEquals(b, [1, 5, 3])
        b.sort()
        self.assertEquals(len(b), 3)
        self.assertEquals(b, [1, 3, 5])
        a.sort()
        self.assertEquals(a, [1, 2, 3, 5, 6])
        a.reverse()
        self.assertEquals(a, [6, 5, 3, 2, 1])
        c: int = sum(e for e in a)
        self.assertEquals(c, 17)
        a.clear()
        self.assertEquals(len(a), 0)
        self.assertEquals(a, [])
        d: int = sum(e for e in b)
        self.assertEquals(d, 9)


if __name__ == '__main__':
    unittest.main()
